/*
 * IncDecStar.java
 */

/**
 * Class wrapper for an integer
 * @author Nicolás Wolovick
 */

class MyInteger {
	public int value;
	public MyInteger(int v) {
		this.value = v;
	}
}

/**
 *
 * @author Nicolás Wolovick
 */
public class IncDecStar {

	/** Creates a new instance of IncDecStar */
	public IncDecStar() {
	}

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) {
		MyInteger N = new MyInteger(0); //shared variable, the object wrapper of int
		IncDecThread incDecThread0 = new IncDecThread(0,N);
		IncDecThread incDecThread1 = new IncDecThread(1,N);
		TesterThread testerThread = new TesterThread(N);
		incDecThread0.start();
		incDecThread1.start();
		testerThread.start();
	}

}

/**
 *
 * @author Nicolás Wolovick
 */
class IncDecThread extends Thread {

	private MyInteger N = null;
	private int id;

	/** Creates a new instance of Worker */
	public IncDecThread(int id, MyInteger N) {
		this.id = id;
		this.N = N;
	}

	public void run(){
		System.out.println("IncDec " + id + " start");
		while(true){
			N.value++;
			N.value--;
		}
	}
}

/**
 *
 * @author Nicolás Wolovick
 */
class TesterThread extends Thread {

	private MyInteger N = null;

	/** Creates a new instance of Worker */
	public TesterThread(MyInteger N) {
		this.N = N;
	}

	public void run(){
		System.out.println("Tester start");
		while(true){
			assert 0<=N.value && N.value<=2 : "Invalid Invariant, non atomic N:=N+1 "; // java -esa -ea.
			System.out.println("N= " + N.value);
		}
	}
}